<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>Assembly Basic Operations</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">
	<link rel="stylesheet" href="css/theme/league.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<!-- UGLY inline CSS but using this div to test Unclassified banner -->
	<!-- <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div> -->
	<div class="reveal">
		<div class="slides">
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h1>Assembly Basic Operations</h1>
				<h4>90th Cyberspace Operations Squadron</h4>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<h2>Overview</h2>
				<h3>Assembly Slides are organized by unit</h3>
				<ul>
					<li>Introduction to ASM</li>
					<li>ASM Basic Operations</li>
					<li>ASM Control Flow</li>

				</ul>
				<aside class="notes">
					Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
					instructor view!!
				</aside>
			</section>

			<!-- FILL WITH SECTIONS (SLIDES) -->

			<section>
				<section>
					<h2>Overview</h2>
					<ul>
						<li>Arithmetic</li>
						<li>Controlling <em>The Stack</em>&trade;</li>
						<li>Negative Numbers and Bitwise Operations</li>
					</ul>


				</section>
				<section>
					<h2>Objectives</h2>
					<a href="../objectives.html" target="_blank">ASM Basic Operations Objectives</a>
				</section>

				<section>
					<h2>ASM Basic Operations </h2>
					<ul>
						<li>Arithmetic</li>
						<li>Controlling <em>The Stack</em>&trade;</li>
						<li>Negative Numbers and Bitwise Operations</li>
					</ul>
				</section>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<section>
					<h2>Arithmetic</h2>
					<ul>
						<li>add</li>
						<li>sub</li>
						<li>mul</li>
						<li>div</li>
						<li>Lab 3</li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">add</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
mov rax, 1
add rax, 2      
; rax now contains 3
						</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">sub</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
mov rax, 7
sub rax, 2      
; rax now contains 5
											</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">mul</p>
					<p style="font-size:120%; font-weight:bold"></p>multiplies by r/e/ax <br><em>based on operand
						size</em></p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
mov eax, 7
mov ecx, 2
mul ecx      
;eax now contains 14
																</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:120%; font-weight:bold"></p>multiplies by r/e/ax <br><em>based on operand
						size</em></p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
mov rax, 5
mov rcx, 7
mul rcx      
;rax now contains 35
															</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">mul</p>
					<p style="font-size:120%; font-weight:bold">Storing <em>multiplication</em> results</p>
					<table>
						<tr>
							<td><em>Operand Size</em></td>
							<td><em>First Source</em></td>
							<td><em>Destination</em></td>
						</tr>

						<tr>
							<td>byte</td>
							<td>al</td>
							<td>ax</td>
						</tr>

						<tr>
							<td>word</td>
							<td>ax</td>
							<td>dx:ax</td>
						</tr>

						<tr>
							<td>dword</td>
							<td>eax</td>
							<td>edx:eax</td>
						</tr>

						<tr>
							<td>qword</td>
							<td>rax</td>
							<td>rdx:rax</td>
						</tr>

					</table>


				</section>


				<section>
					<p style="font-size:220%; font-weight:bold">div</p>
					<ul>
						<li>takes one argument</li>
						<li><em>rdx</em> is needed for the remainder</li>
						<li>rdx must be set to 0 before div</li>
						<em>rax / src </em>
						<li>results &rArr; rax</li>
						<li>remainder &rArr; rdx</li>

					</ul>

				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">div</p>
					<p style="font-size:120%; font-weight:bold">Storing <em>division</em> results</p>
					<table>
						<tr>
							<td><em>Maximum</em></td>
							<td><em>Dividend</em></td>
							<td><em>Quotient</em></td>
							<td><em>Remainder</em></td>
						</tr>

						<tr>
							<td>byte/word</td>
							<td>ax</td>
							<td>al</td>
							<td>ah</td>
						</tr>

						<tr>
							<td>word/dword</td>
							<td>dx:ax</td>
							<td>ax</td>
							<td>dx</td>
						</tr>

						<tr>
							<td>dword/qword</td>
							<td>edx:eax</td>
							<td>eax</td>
							<td>edx</td>
						</tr>

						<tr>
							<td>dqword/qword</td>
							<td>rdx:rax</td>
							<td>rax</td>
							<td>rdx</td>
						</tr>


					</table>

					<p style="font-size: 80%;">See <a href="https://c9x.me/x86/html/file_module_x86_id_72.html">here</a>
						and <a href="https://www.felixcloutier.com/x86/div">here</a> for more information.</p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold"><em>inc</em> and <em>dec</em></p>
					<ul>

						<li>
							<p style="font-size:120%; font-weight:bold">inc</p>

							<em>increments</em> i.e. adds 1 to a register
						</li>

						<br>
						<li>
							<p style="font-size:120%; font-weight:bold">dec</p>

							<em>decrements</em> i.e. subtracts 1 from a register
						</li>
					</ul>

				</section>
				<section>
					<p><em style="color:#f82571">inc</em>rement and <em style="color: #f82571">dec</em>rement</p>

					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
mov rax, 1      
inc rax         
; rax now contains 2
inc rax         
; rax now contains 3
dec rax         
; rax now contains 2
											</code></pre>
						</div>
					</div>
				</section>

				<section>
					<h3><em>With a partner discuss </em>- </h3>
					<p style="font-size:220%; font-weight:bold">
						What unique feature do mul, div, inc, and dec share?</p>

				</section>

				<section>
					<h3><em>With a partner discuss </em>- </h3>
					<p style="font-size:220%; font-weight:bold">How would you find modulo in Assembly?</p>

				</section>



				<section>
					<h3>Lab 3 </h3>
					<img src="../../assets/success_lab3.png" alt="Lab 3 success" width="500">
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<p style="font-size:220%; font-weight:bold"><em>The Stack </em> &trade;</p>
					<ul>
						<li>stack/base pointers</li>
						<li>adding/removing space to the stack</li>
						<li>push/pop</li>
						<li>Lab 4</li>
					</ul>
				</section>

				<section>
					<p style="font-size:120%; font-weight:bold"><em>The Stack </em> &trade;</p>
					<p style="font-weight:bold">i.e. "the call stack"</p>
					<p>Grows from high address to low - <em>last</em> in <em>first</em> out</p>
					<img src="../../assets/stack1.png" alt="The Stack" height="320">
					<p style="font-size: 80%;">See also <a
							href="http://www.cs.tau.ac.il/~maon/teaching/2014-2015/seminar/seminar1415a-lec6-runtime.pdf">here</a>
					</p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">The <em style="color:#f82571">stack </em> pointer
					</p>
					<p><em style="color:#f82571">rsp</em> (or <em>esp</em>) - points to the top of the stack</p>
					<p style="font-size:220%; font-weight:bold">The <em style="color:#a6e22e">base </em> pointer</p>
					<p><em style="color:#a6e22e">rbp</em> (or <em>ebp</em>) - points to the <i>base</i> of the stack
						frame</p>
				</section>

				<section>
					<table>
						<tr>
							<td><em>Address</em></td>
							<td><em>Value/Reg</em></td>
						</tr>
						<tr>

							<td>0x0000</td>
							<td><em style="color:#f82571">rsp</em> </td>
						</tr>
						<tr>
							<td>0x0008</td>
							<td>0x0000</td>
						</tr>
						<tr>
							<td>0x0010</td>
							<td>0x0000</td>
						</tr>
						<tr>
							<td>0x0018</td>
							<td><em style="color:#a6e22e">rbp</em></td>
						</tr>
					</table>
					<p style="font-weight:bold;">Note the memory <em>addresses</em></p>
					<p style="font-size: 70%;">See also <a
							href="https://blog.holbertonschool.com/hack-virtual-memory-stack-registers-assembly-code/"
							style="color:#4b031d">here</a></p>


				</section>

				<section>
					<table>
						<tr>
							<td width="60%"><img src="../../assets/stack2.png" alt="The Stack in relation to EBP"
									height="360">
								<p style="font-size: 70%;">Original graphic <a
										href="http://www.cs.tau.ac.il/~maon/teaching/2014-2015/seminar/seminar1415a-lec6-runtime.pdf">here</a>
								</p>
							</td>
							<td>
								<ul style="font-size: 80%;">
									<li>data is typically accessed with <em style="color:#a6e22e">rbp</em> (on
										X86_64)
									</li>
									<li><em style="color:#a6e22e">ebp</em> separates function parameters (green) and
										local variables (blue)</li>
									<li>the stack return address is always <em style="color:#a6e22e">ebp</em> + 4
									</li>
									<li><em style="color:#f82571">rsp</em>/esp changes constantly</li>
								</ul>
							</td>
						</tr>
					</table>

				</section>

				<section>
					<h2>Expanding the Stack Frame</h2>
					<p><em style="color:#f82571">rsp</em> can be changed to allocate more stack space</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>

sub rsp, 16

add rsp, 16

											</code></pre>
						</div>
					</div>
					<p>but it must be restored before the function returns</p>
					<p style="font-size: 80%;">See also <a
							href="https://stackoverflow.com/questions/46790666/how-is-stack-memory-allocated-when-using-push-or-sub-x86-instructions">here</a>
						and <a href="https://www.cs.uaf.edu/2012/fall/cs301/lecture/09_21_stack.html">here</a></p>
				</section>

				<section>
					<p style="font-size:200%; font-weight:bold"><em>push</em> and <em>pop</em></p>
					<p style="font-size:120%;">Two of the most fundamental commands</p>
					<img src="../../assets/pile_of_dishes_rev.png" height="360" alt="Pile of dishes for push and pop">
					<p style="font-size: 70%;">Original image <a
							href="https://learn.adacore.com/labs/bug-free-coding/chapters/stack.html">here</a></p>

				</section>

				<section>
					<p style="font-size:140%; font-weight:bold"><em style="color:#f82571">push</em><br>
						subtracts a pointer width* of space from <em style="color:#f82571">rsp</em>
						<br> places the data in that space </p>

					<hr>
					<p style="font-size:140%; font-weight:bold">
						<em style="color:#a6e22e">pop</em>
						<br> does the opposite i.e. <br>
						adds a pointer width* of space to <em style="color:#f82571">rsp</em></p>


				</section>

				<section>
					<p style="font-size:160%; font-weight:bold"><em style="color:#a6e22e">pop</em> <br>in the reverse
						order of <br><em style="color:#f82571">push</em></p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 28px; line-height: 32px;"><code>	
.first_func
	mov rax, 1
	mov rdx, 10
					
	push rax
	push rdx			
; do things
	pop rdx
	pop rax	</code></pre>
						</div>
					</div>
				</section>

				<section>
					<table>
						<tr>
							<td>After a <em>push</em></td>
							<td>After a <em>pop</em></td>
						</tr>
						<tr>
							<td><img src="../../assets/push_reg.png" alt="register after push"></td>
							<td style="vertical-align : top"><img src="../../assets/pop_reg.png"
									alt="register after pop"><br></td>
						</tr>

					</table>
				</section>


				<section>
					<h3>Lab 4 </h3>
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<p style="font-size:140%; font-weight:bold">Negative numbers<br>
						and
						<br>Bitwise operations</p>
					<ul>
						<li>Two's complement</li>
						<li>sub-registers and sign-extending</li>
						<li>left shift/right shift</li>
						<li>AND / OR / XOR</li>
						<li>bit rotating</li>
						<li>Lab 5</li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">Two's complement</p>
					<p style="font-size:120%; font-weight:bold">Most common negative number</p>
					<p>left most bit:</p>
					<ul>
						<li>0 - positive</li>
						<li>1 - negative</li>
					</ul>
				</section>
				<section>


					<p style="font-size:160%; font-weight:bold">Two's complement </p>
					<ul>
						<p>Two methods:</p>
						<hr>
						<em>1.</em>
						<li>subtract 1 </li>
						<li>find one's complement (binary inverse)</li>
						<hr>
						<em>2.</em>
						<li>find one's complement</li>
						<li>add 1 </li>
						<hr>
					</ul>
				</section>

				<section>
					<h3>sub-registers and sign-extending</h3>
					<h3>There are multiple <em>sign aware</em> operations in assembly</h3>

				</section>

				<section>
					<p style="color:#f82571;  font-size:220%; font-weight:bold">movsx</p>
					<p>similar to </p>
					<p style="color:#a6e22e;  font-size:220%; font-weight:bold">movzx</p>
					<h3>maintains sign during copy</h3>

					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>
movsx ebx,bx
											</code></pre>
						</div>
					</div>
				</section>

				<section>
					<h4><em>Variations on</em></h3>
						<h3>left shift/right shift</h3>
						<ul>
							<li>shl/shr</li>
							<li>sal/sar</li>
							<li><i>rol/ror</i></li>

						</ul>


				</section>

				<section>

					<p style="font-size:120%;">Two <em>unsigned</em> shift operations</p>
					<p style="font-size:120%;"> shift left / shift right</p>
					<p style="font-size:220%; font-weight:bold">shl</p>
					<p style="font-size:220%; font-weight:bold">shr</p>
					<ul>
						<li>moves number of bits specified</li>
						<li>bits fall off the end - last one goes to <em>carry flag</em></li>
						<li>space padded with 0's</li>
					</ul>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">shl</p>
					<table>
						<tr>
							<td><em>state</em></td>
							<td><em>binary</em></td>
							<td><em>decimal</em></td>
						</tr>
						<tr>
							<td>start</td>
							<td>00000001</td>
							<td>1</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">shl</em> rax, 1</td>
							<td>00000010</td>
							<td>2</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">shl</em> rax, 3</td>
							<td>00010000</td>
							<td>16</td>
						</tr>
					</table>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">shr</p>
					<table>
						<tr>
							<td><em>state</em></td>
							<td><em>binary</em></td>
							<td><em>decimal</em></td>
						</tr>
						<tr>
							<td>start</td>
							<td>00100000</td>
							<td>32</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">shr</em> rax, 1</td>
							<td>00010000</td>
							<td>16</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">shr</em> rax, 4</td>
							<td>00000001</td>
							<td>1</td>
						</tr>
					</table>
				</section>



				<section>
					<p style="font-size:220%; font-weight:bold">sal</p>
					<p style="font-size:220%; font-weight:bold">sar</p>
					<p style="font-size:120%;">sign aware</p>
					<p style="font-size:120%;">shift arithmetic left/right</h3>
					<p style="font-size: 70%;">See also <a
							href="https://www.amd.com/system/files/TechDocs/24594.pdf">The AMD Developer's
							Manual</a>
					</p>
				</section>

				<section>

					<p style="font-size:220%; font-weight:bold">sal / sar</p>

					<p style="font-size:120%; font-weight:bold">shift arithmetic left/right</p>
					<ul>
						<li>similar to shr/shl</li>
						<li>bits are shifted off the end</li>
						<li>sign of the resulting value is retained</li>
					</ul>
				</section>

				<section>
					<h3>bit rotating</h3>
					<h3>bits rotated off the end - back to the other side</h3>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>mov rax, 1      
rol rax, 1
; rax contains 2 (00000010)      
ror rax, 1      
ror rax, 1      
; rax now (10000000)</code></pre>
						</div>
					</div>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">
				<section>
					<p style="font-size:220%; font-weight:bold">and</p>
					<p style="font-size:220%; font-weight:bold">or</p>
					<p style="font-size:220%; font-weight:bold">xor</p>
					<p style="font-size:220%; font-weight:bold">not</p>
				</section>

				<section>
					<p style="font-size:220%; font-weight:bold">and == both</p>
					<p style="font-size:220%; font-weight:bold">or == either</p>

					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>      
mov rax, 1
mov rcx, 5
								
and rax, rcx            
; rax contains 00000001
or rax, rcx             
; rax contains 00000101</code></pre>
						</div>
					</div>
				</section>

				<section>

					<p style=" font-size:220%; font-weight:bold">not == neither</p>
					<div class="sl-block" data-block-type="code">
						<div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none"
							style="z-index: 10;">
							<pre style="font-size: 36px; line-height: 42px;"><code>      
mov rcx, 1
       
not rcx                 
; rcx now 11111110</code></pre>
						</div>
					</div>
				</section>

				<section>
					<p style=" font-size:220%; font-weight:bold">xor == e <em style="color:#f82571;">x</em>clusively
						in one</p>
					<table>
						<tr>
							<td><em>Assembly</em></td>
							<td><em>First Value</em></td>
							<td><em>Second Value</em></td>
							<td><em>Result</em></td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">xor </em> rax, rax</td>
							<td>01010011</td>
							<td>01010011</td>
							<td><em style="color:#B22222;">00000000</em></td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">xor </em>rax, rcx</td>
							<td>01000010</td>
							<td>0100<em style="color:#f82571;">1</em>010</td>
							<td>00001000</td>
						</tr>
						<tr>
							<td><em style="color:#f82571;">xor </em>rcx, rax</td>
							<td>0<em style="color:#f82571;">1</em>0010<em style="color:#f82571;">1</em>0</td>
							<td>00001000</td>
							<td>01000010</td>
						</tr>
					</table>
				</section>




				<section>
					<h3>Lab 5 </h3>
				</section>
			</section>
			<section data-background-image="images/org_symbol.png" data-background-size="13%"
				data-background-position="top 5% left 5%">

				<section>
					<h3>Reflection</h3>
					<ul>
						<li>What are the different bitwise <em>shifts</em>?</li>
						<li><em>Why</em> are there different bitwise shifts?</li>
						<li>and, or, not, xor - how are they similar?</li>
						<li>and, or, not, xor - how are they different?</li>
					</ul>
				</section>


				<section data-background-image="images/org_symbol.png" data-background-size="13%"
					data-background-position="top 5% left 5%">
					<h2>Conclusion</h2>

					<ul>
						<li>Arithmetic</li>
						<li>Controlling <em>The Stack</em>&trade;</li>
						<li>Negative Numbers and Bitwise Operations</li>
					</ul>
				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="13%"
					data-background-position="top 5% left 5%">
					<h2>Questions?</h2>
				</section>
			</section>
		</div>
	</div>
	<!-- This footer doesn't work. Need to play with CSS -->
	<!-- <footer style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer> -->

	<!-- DO NOT TOUCH -->
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>